gtkmm: Gtk::DropTarget Class Reference

gtkmm 4.2.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::DropTarget Class Reference
Event Controllers and Gestures

Event controller to receive DND drops. More...

`#include <gtkmm/droptarget.h>`

Inheritance diagram for Gtk::DropTarget:
[legend]

## Public Member Functions
| DropTarget (DropTarget&& src) noexcept
DropTarget& | operator= (DropTarget&& src) noexcept
| ~DropTarget () noexcept override
GtkDropTarget* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkDropTarget* | gobj () const
| Provides access to the underlying C GObject. More...
GtkDropTarget* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_gtypes (const std::vector< GType >& types)
| Sets the supported Types for this drop target. More...
std::vector< GType > | get_gtypes () const
| Gets a vector of supported Types. More...
Glib::RefPtr< Gdk::ContentFormats > | get_formats ()
| Gets the data formats that this drop target accepts. More...
Glib::RefPtr< const Gdk::ContentFormats > | get_formats () const
| Gets the data formats that this drop target accepts. More...
void | set_actions (Gdk::DragAction actions)
| Sets the actions that this drop target supports. More...
Gdk::DragAction | get_actions () const
| Gets the actions that this drop target supports. More...
void | set_preload (bool preload=true)
| Sets whether data should be preloaded on hover. More...
bool | get_preload () const
| Gets whether data should be preloaded on hover. More...
Glib::RefPtr< Gdk::Drop > | get_drop ()
| Gets the currently handled drop operation. More...
Glib::RefPtr< const Gdk::Drop > | get_drop () const
| Gets the currently handled drop operation. More...
Glib::ValueBase | get_value () const
| Gets the current drop data, as a `GValue`. More...
void | reject ()
| Rejects the ongoing drop operation. More...
Glib::PropertyProxy< Gdk::DragAction > | property_actions ()
| The `GdkDragActions` that this drop target supports. More...
Glib::PropertyProxy_ReadOnly< Gdk::DragAction > | property_actions () const
| The `GdkDragActions` that this drop target supports. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Drop > > | property_drop () const
| The `GdkDrop` that is currently being performed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::ContentFormats > > | property_formats () const
| The `GdkContentFormats` that determine the supported data formats. More...
Glib::PropertyProxy< bool > | property_preload ()
| Whether the drop data should be preloaded when the pointer is only hovering over the widget but has not been released. More...
Glib::PropertyProxy_ReadOnly< bool > | property_preload () const
| Whether the drop data should be preloaded when the pointer is only hovering over the widget but has not been released. More...
Glib::PropertyProxy_ReadOnly< GValue* > | property_value () const
| The value for this drop operation. More...
Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::Drop >&)> | signal_accept ()
| Only one signal handler is called. More...
Glib::SignalProxy< Gdk::DragAction(double, double)> | signal_enter ()
| Only one signal handler is called. More...
Glib::SignalProxy< Gdk::DragAction(double, double)> | signal_motion ()
| Only one signal handler is called. More...
Glib::SignalProxy< void()> | signal_leave ()
Glib::SignalProxy< bool(const Glib::ValueBase&, double, double)> | signal_drop ()
| Only one signal handler is called. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController&& src) noexcept
EventController& | operator= (EventController&& src) noexcept
| ~EventController () noexcept override
GtkEventController* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget* | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget* | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller. More...
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller. More...
Glib::ustring | get_name () const
| Gets the name of controller. More...
void | set_name (const Glib::ustring& name)
| Sets a name on the controller that can be used for debugging. More...
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller, and `nullptr` at other times. More...
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller, and 0 otherwise. More...
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller, and `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller, and `nullptr` at other times. More...
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller, and 0 otherwise. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_widget () const
| The widget receiving the `GdkEvents` that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle. More...
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< DropTarget > | create (GType type, Gdk::DragAction actions)
| Creates a new `GtkDropTarget` object. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::DropTarget > | wrap (GtkDropTarget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

Event controller to receive DND drops.

Gtk::DropTarget is an event controller implementing a simple way to receive Drag-and-Drop operations.

The most basic way to use a Gtk::DropTarget to receive drops on a widget is to create it via create() passing in the GType of the data you want to receive and connect to signal_drop() to receive the data.

Gtk::DropTarget supports more options, such as:

- rejecting potential drops via signal_accept() and the reject() method to let other drop targets handle the drop
- tracking an ongoing drag operation before the drop via signal_enter(), signal_motion() and signal_leave()
- configuring how to receive data by setting property_preload() and listening for its availability via property_value()

However, Gtk::DropTarget is ultimately modeled in a synchronous way and only supports data transferred via GType.
If you want full control over an ongoing drop, the Gtk::DropTargetAsync object gives you this ability.

While a pointer is dragged over the drop target's widget and the drop has not been rejected, that widget will receive the Gtk::StateFlags::DROP_ACTIVE state, which can be used to style the widget.

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ DropTarget()

Gtk::DropTarget::DropTarget | ( | DropTarget&& | src | ) |
| noexcept

## ◆ ~DropTarget()

Gtk::DropTarget::~DropTarget | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<DropTarget> Gtk::DropTarget::create | ( | GType | type,
|  | Gdk::DragAction | actions
| ) |  |
| static

Creates a new `GtkDropTarget` object.

If the drop target should support more than 1 type, pass G_TYPE_INVALID for type and then call [method Gtk.DropTarget.set_gtypes].

Parameters

  type | The supported type or G_TYPE_INVALID.
  actions | The supported actions.

Returns
  The new `GtkDropTarget`.

## ◆ get_actions()

Gdk::DragAction Gtk::DropTarget::get_actions | ( |  | ) | const

Gets the actions that this drop target supports.

Returns
  The actions that this drop target supports.

## ◆ get_drop() [1/2]

Glib::RefPtr<Gdk::Drop> Gtk::DropTarget::get_drop | ( |  | ) |

Gets the currently handled drop operation.

If no drop operation is going on, `nullptr` is returned.

Returns
  The current drop.

## ◆ get_drop() [2/2]

Glib::RefPtr<const Gdk::Drop> Gtk::DropTarget::get_drop | ( |  | ) | const

Gets the currently handled drop operation.

If no drop operation is going on, `nullptr` is returned.

Returns
  The current drop.

## ◆ get_formats() [1/2]

Glib::RefPtr<Gdk::ContentFormats> Gtk::DropTarget::get_formats | ( |  | ) |

Gets the data formats that this drop target accepts.

If the result is `nullptr`, all formats are expected to be supported.

Returns
  The supported data formats.

## ◆ get_formats() [2/2]

Glib::RefPtr<const Gdk::ContentFormats> Gtk::DropTarget::get_formats | ( |  | ) | const

Gets the data formats that this drop target accepts.

If the result is `nullptr`, all formats are expected to be supported.

Returns
  The supported data formats.

## ◆ get_gtypes()

std::vector<GType> Gtk::DropTarget::get_gtypes | ( |  | ) | const

Gets a vector of supported Types.

If no type have been set, an empty vector will be returned.

Returns
  Vector of types.

## ◆ get_preload()

bool Gtk::DropTarget::get_preload | ( |  | ) | const

Gets whether data should be preloaded on hover.

Returns
  `true` if drop data should be preloaded.

## ◆ get_type()

static GType Gtk::DropTarget::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_value()

Glib::ValueBase Gtk::DropTarget::get_value | ( |  | ) | const

Gets the current drop data, as a `GValue`.

Returns
  The current drop data.

## ◆ gobj() [1/2]

GtkDropTarget* Gtk::DropTarget::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkDropTarget* Gtk::DropTarget::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkDropTarget* Gtk::DropTarget::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

DropTarget& Gtk::DropTarget::operator= | ( | DropTarget&& | src | ) |
| noexcept

## ◆ property_actions() [1/2]

Glib::PropertyProxy< Gdk::DragAction > Gtk::DropTarget::property_actions | ( |  | ) |

The `GdkDragActions` that this drop target supports.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_actions() [2/2]

Glib::PropertyProxy_ReadOnly< Gdk::DragAction > Gtk::DropTarget::property_actions | ( |  | ) | const

The `GdkDragActions` that this drop target supports.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_drop()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gdk::Drop> > Gtk::DropTarget::property_drop | ( |  | ) | const

The `GdkDrop` that is currently being performed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_formats()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gdk::ContentFormats> > Gtk::DropTarget::property_formats | ( |  | ) | const

The `GdkContentFormats` that determine the supported data formats.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_preload() [1/2]

Glib::PropertyProxy< bool > Gtk::DropTarget::property_preload | ( |  | ) |

Whether the drop data should be preloaded when the pointer is only hovering over the widget but has not been released.

Setting this property allows finer grained reaction to an ongoing drop at the cost of loading more data.

The default value for this property is `false` to avoid downloading huge amounts of data by accident.

For example, if somebody drags a full document of gigabytes of text from a text editor across a widget with a preloading drop target, this data will be downloaded, even if the data is ultimately dropped elsewhere.

For a lot of data formats, the amount of data is very small (like GDK_TYPE_RGBA), so enabling this property does not hurt at all. And for local-only Drag-and-Drop operations, no data transfer is done, so enabling it there is free.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_preload() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::DropTarget::property_preload | ( |  | ) | const

Whether the drop data should be preloaded when the pointer is only hovering over the widget but has not been released.

Setting this property allows finer grained reaction to an ongoing drop at the cost of loading more data.

The default value for this property is `false` to avoid downloading huge amounts of data by accident.

For example, if somebody drags a full document of gigabytes of text from a text editor across a widget with a preloading drop target, this data will be downloaded, even if the data is ultimately dropped elsewhere.

For a lot of data formats, the amount of data is very small (like GDK_TYPE_RGBA), so enabling this property does not hurt at all. And for local-only Drag-and-Drop operations, no data transfer is done, so enabling it there is free.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_value()

Glib::PropertyProxy_ReadOnly< GValue* > Gtk::DropTarget::property_value | ( |  | ) | const

The value for this drop operation.

This is `nullptr` if the data has not been loaded yet or no drop operation is going on.

Data may be available before the [signal Gtk.DropTarget::drop] signal gets emitted - for example when the [property Gtk.DropTarget:preload] property is set. You can use the signal_notify() signal to be notified of available data.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ reject()

void Gtk::DropTarget::reject | ( |  | ) |

Rejects the ongoing drop operation.

If no drop operation is ongoing, i.e when [property Gtk.DropTarget:drop] is `nullptr`, this function does nothing.

This function should be used when delaying the decision on whether to accept a drag or not until after reading the data.

## ◆ set_actions()

void Gtk::DropTarget::set_actions | ( | Gdk::DragAction | actions | ) |

Sets the actions that this drop target supports.

Parameters

  actions | The supported actions.

## ◆ set_gtypes()

void Gtk::DropTarget::set_gtypes | ( | const std::vector< GType > & | types | ) |

Sets the supported Types for this drop target.

Parameters

  types | All supported Types that can be dropped.

## ◆ set_preload()

void Gtk::DropTarget::set_preload | ( | bool | preload = `true` | ) |

Sets whether data should be preloaded on hover.

Parameters

  preload | `true` to preload drop data.

## ◆ signal_accept()

Glib::SignalProxy<bool(const Glib::RefPtr<Gdk::Drop>&)> Gtk::DropTarget::signal_accept | ( |  | ) |

Only one signal handler is called.

If you connect a handler, it must be called before (instead of) the default handler, otherwise it won't be called. Set the after parameter in connect() to `false`.

Slot Prototype:
  `bool on_my_accept(const Glib::RefPtr<Gdk::Drop>& drop)`

Flags: Run Last

Emitted on the drop site when a drop operation is about to begin.

If the drop is not accepted, `false` will be returned and the drop target will ignore the drop. If `true` is returned, the drop is accepted for now but may be rejected later via a call to [method Gtk.DropTarget.reject] or ultimately by returning `false` from a [signal Gtk.DropTarget::drop] handler.

The default handler for this signal decides whether to accept the drop based on the formats provided by the drop.

If the decision whether the drop will be accepted or rejected depends on the data, this function should return `true`, the [property Gtk.DropTarget:preload] property should be set and the value should be inspected via the ::notify:value signal, calling [method Gtk.DropTarget.reject] if required.

Parameters

  drop | The `GdkDrop`.

Returns
  `true` if drop is accepted.

## ◆ signal_drop()

Glib::SignalProxy<bool(const Glib::ValueBase&, double, double)> Gtk::DropTarget::signal_drop | ( |  | ) |

Only one signal handler is called.

If you connect a handler, it must be called before (instead of) the default handler, otherwise it won't be called. Set the after parameter in connect() to `false`.

Slot Prototype:
  `bool on_my_drop(const Glib::ValueBase& value, double x, double y)`

Flags: Run Last

Emitted on the drop site when the user drops the data onto the widget.

The signal handler must determine whether the pointer position is in a drop zone or not. If it is not in a drop zone, it returns `false` and no further processing is necessary.

Otherwise, the handler returns `true`. In this case, this handler will accept the drop. The handler is responsible for rading the given value and performing the drop operation.

Parameters

  value | The Value being dropped.
  x | The x coordinate of the current pointer position.
  y | The y coordinate of the current pointer position.

Returns
  Whether the drop was accepted at the given pointer position.

## ◆ signal_enter()

Glib::SignalProxy<Gdk::DragAction(double, double)> Gtk::DropTarget::signal_enter | ( |  | ) |

Only one signal handler is called.

If you connect a handler, it must be called before (instead of) the default handler, otherwise it won't be called. Set the after parameter in connect() to `false`.

Slot Prototype:
  `Gdk::DragAction on_my_enter(double x, double y)`

Flags: Run Last

Emitted on the drop site when the pointer enters the widget.

It can be used to set up custom highlighting.

Parameters

  x | The x coordinate of the current pointer position.
  y | The y coordinate of the current pointer position.

Returns
  Preferred action for this drag operation or 0 if dropping is not supported at the current x, y location.

## ◆ signal_leave()

Glib::SignalProxy<void()> Gtk::DropTarget::signal_leave | ( |  | ) |

Slot Prototype:
  `void on_my_leave()`

Flags: Run Last

Emitted on the drop site when the pointer leaves the widget.

Its main purpose it to undo things done in [signal Gtk.DropTarget::enter].

## ◆ signal_motion()

Glib::SignalProxy<Gdk::DragAction(double, double)> Gtk::DropTarget::signal_motion | ( |  | ) |

Only one signal handler is called.

If you connect a handler, it must be called before (instead of) the default handler, otherwise it won't be called. Set the after parameter in connect() to `false`.

Slot Prototype:
  `Gdk::DragAction on_my_motion(double x, double y)`

Flags: Run Last

Emitted while the pointer is moving over the drop target.

Parameters

  x | The x coordinate of the current pointer position.
  y | The y coordinate of the current pointer position.

Returns
  Preferred action for this drag operation or 0 if dropping is not supported at the current x, y location.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::DropTarget > wrap | ( | GtkDropTarget * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.